
dictionary SettingsMetaDict;

class FMetaSetting
{
	Meta::PluginSetting@ Setting = null;
	float MinFloat = NumericLimits::FLT_LOWEST / 2;
	float MaxFloat = NumericLimits::FLT_MAX / 2;
	int32 MinInt = NumericLimits::INT32_MIN / 2;
	int32 MaxInt = NumericLimits::INT32_MAX / 2;
	uint32 MinUInt = 0;
	uint32 MaxUInt = NumericLimits::UINT32_MAX / 2;
	bool bIsDraggable = false;
	bool bIsSlider = false;
	bool bIsColor = false;
	bool bIsMultiLine = false;
	bool bIsPassword = false;

	FMetaSetting() {};


	FMetaSetting(const string &in varName, bool defaultValue) {
		@Setting = Meta::ExecutingPlugin().GetSetting(varName);

		SettingsMetaDict[varName] = this;
	}


	FMetaSetting(const string &in varName, float defaultValue, float minValue = NumericLimits::FLT_LOWEST / 2, float maxValue = NumericLimits::FLT_MAX / 2, bool draggable = false) {
		@Setting = Meta::ExecutingPlugin().GetSetting(varName);

		MinFloat = minValue;
		MaxFloat = maxValue;
		bIsDraggable = draggable;
		bIsSlider = (minValue != NumericLimits::FLT_LOWEST / 2 && maxValue != NumericLimits::FLT_MAX / 2);
		SettingsMetaDict[varName] = this;
	}


	FMetaSetting(const string &in varName, int8 defaultValue, int8 minValue = NumericLimits::INT8_MIN / 2, int8 maxValue = NumericLimits::INT8_MAX / 2, bool draggable = false) {
		@Setting = Meta::ExecutingPlugin().GetSetting(varName);

		MinInt = minValue;
		MaxInt = maxValue;
		bIsDraggable = draggable;
		bIsSlider = (minValue != NumericLimits::INT8_MIN / 2 && maxValue != NumericLimits::INT8_MAX / 2);
	   SettingsMetaDict[varName] = this;
	}


	FMetaSetting(const string &in varName, int16 defaultValue, int16 minValue = NumericLimits::INT16_MIN / 2, int16 maxValue = NumericLimits::INT16_MAX / 2, bool draggable = false) {
		@Setting = Meta::ExecutingPlugin().GetSetting(varName);

		MinInt = minValue;
		MaxInt = maxValue;
		bIsDraggable = draggable;
		bIsSlider = (minValue != NumericLimits::INT16_MIN / 2 && maxValue != NumericLimits::INT16_MAX / 2);
		SettingsMetaDict[varName] = this;
	}


	FMetaSetting(const string &in varName, int32 defaultValue, int32 minValue = NumericLimits::INT32_MIN / 2, int32 maxValue = NumericLimits::INT32_MAX / 2, bool draggable = false) {
		@Setting = Meta::ExecutingPlugin().GetSetting(varName);

		MinInt = minValue;
		MaxInt = maxValue;
		bIsDraggable = draggable;
		bIsSlider = (minValue != NumericLimits::INT32_MIN / 2 && maxValue != NumericLimits::INT32_MAX / 2);
		SettingsMetaDict[varName] = this;
	}


	FMetaSetting(const string &in varName, uint8 defaultValue, uint8 minValue = NumericLimits::UINT8_MIN / 2, uint8 maxValue = NumericLimits::UINT8_MAX / 2, bool draggable = false) {
		@Setting = Meta::ExecutingPlugin().GetSetting(varName);

		MinUInt = minValue;
		MaxUInt = maxValue;
		bIsDraggable = draggable;
		bIsSlider = (minValue != NumericLimits::UINT16_MIN / 2 && maxValue != NumericLimits::UINT16_MAX / 2);
		SettingsMetaDict[varName] = this;
	}


	FMetaSetting(const string &in varName, uint16 defaultValue, uint16 minValue = NumericLimits::UINT16_MIN / 2, uint16 maxValue = NumericLimits::UINT16_MAX / 2, bool draggable = false) {
		@Setting = Meta::ExecutingPlugin().GetSetting(varName);

		MinUInt = minValue;
		MaxUInt = maxValue;
		bIsDraggable = draggable;
		bIsSlider = (minValue != NumericLimits::UINT32_MIN / 2 && maxValue != NumericLimits::UINT32_MAX / 2);
		SettingsMetaDict[varName] = this;
	}


	FMetaSetting(const string &in varName, uint32 defaultValue, uint32 minValue = NumericLimits::UINT32_MIN / 2, uint32 maxValue = NumericLimits::UINT32_MAX / 2, bool draggable = false) {
		@Setting = Meta::ExecutingPlugin().GetSetting(varName);

		MinUInt = minValue;
		MaxUInt = maxValue;
		bIsDraggable = draggable;
		SettingsMetaDict[varName] = this;
	}


	FMetaSetting(const string &in varName, vec2 defaultValue, float minValue = NumericLimits::FLT_LOWEST / 2, float maxValue = NumericLimits::FLT_MAX / 2, bool draggable = false) {
		@Setting = Meta::ExecutingPlugin().GetSetting(varName);

		MinFloat = minValue;
		MaxFloat = maxValue;
		bIsDraggable = draggable;
		SettingsMetaDict[varName] = this;
	}


	FMetaSetting(const string &in varName, vec3 defaultValue, float minValue = NumericLimits::FLT_LOWEST / 2, float maxValue = NumericLimits::FLT_MAX / 2, bool draggable = false, bool color = false) {
		@Setting = Meta::ExecutingPlugin().GetSetting(varName);

		MinFloat = minValue;
		MaxFloat = maxValue;
		bIsDraggable = draggable;
		bIsColor = color;
		SettingsMetaDict[varName] = this;
	}


	FMetaSetting(const string &in varName, vec4 defaultValue, float minValue = NumericLimits::FLT_LOWEST / 2, float maxValue = NumericLimits::FLT_MAX / 2, bool draggable = false, bool color = false) {
		@Setting = Meta::ExecutingPlugin().GetSetting(varName);

		MinFloat = minValue;
		MaxFloat = maxValue;
		bIsDraggable = draggable;
		bIsColor = color;
		SettingsMetaDict[varName] = this;
	}


	FMetaSetting(const string &in varName, const string &in defaultValue, int32 maxLength = -1, bool multiline = false, bool password = false) {
		@Setting = Meta::ExecutingPlugin().GetSetting(varName);

		MaxInt = maxLength;
		bIsMultiLine = multiline;
		bIsPassword = password;
		SettingsMetaDict[varName] = this;
	}

	string get_Name() const property { return Setting.Name; }
	string get_Description() const property { return Setting.Description; }
	string get_Category() const property { return Setting.Category; }
	string get_VarName() const property { return Setting.VarName; }
	Meta::PluginSettingType get_Type() const property { return Setting.Type; }
	bool get_bIsVisible() const property { return Setting.Visible; }
}
[Setting category="Recorder" name="Time Step (ms)" description="Upon exceeding this threshold a new sample will be recorded. If the car is moving slowly, the Time Step is the main condition that leads to samples being recorded." min=50 max=10000] int32 Setting_Recorder_TimeStep = 500; FMetaSetting settingMeta_Setting_Recorder_TimeStep = FMetaSetting( "Setting_Recorder_TimeStep" , 500, 50, 10000);
[Setting category="Recorder" name="Position Step (m)" description="Upon exceeding this threshold a new sample will be recorded. If the car is moving fast,the Position Step is the main condition that leads to samples being recorded.." min=0.0 max=100.0] float Setting_Recorder_PositionStep = 1.0; FMetaSetting settingMeta_Setting_Recorder_PositionStep = FMetaSetting( "Setting_Recorder_PositionStep" , 1.0, 0.0, 100.0);
[Setting category="Recorder" name="Clear trails on Play" description="Clear trails when entering Test Mode / Track Validation."] bool Setting_Recorder_ClearTrailsOnPlay = true; FMetaSetting settingMeta_Setting_Recorder_ClearTrailsOnPlay = FMetaSetting( "Setting_Recorder_ClearTrailsOnPlay" , true);

[Setting category="Display" name="Spectrum Palette" description="Changes the colors of Spectrum used to color code the Stats and the Time Control."] RouteSpectrum::ESpectrumPalette RequestedPalette = RouteSpectrum::ESpectrumPalette::Spectrum; FMetaSetting settingMeta_RequestedPalette = FMetaSetting( "RequestedPalette" , RouteSpectrum::ESpectrumPalette::Spectrum);

[Setting category="Display" name="Show Selected Only" description="Show only the selected Editor Route."] bool Setting_RenderSelectedOnly = false; FMetaSetting settingMeta_Setting_RenderSelectedOnly = FMetaSetting( "Setting_RenderSelectedOnly" , false);

[Setting category="Display" name="Route Color" description="Line-Color unselected Editor Routes." min=0.0 max=1.0 color] vec3 Setting_RouteColor = vec3(0.9, 0.9, 0.9); FMetaSetting settingMeta_Setting_RouteColor = FMetaSetting( "Setting_RouteColor" , vec3(0.9, 0.9, 0.9), 0.0, 1.0, false, true);
[Setting category="Display" name="Selected Route Color" description="Line-Color selected Editor Routes." min=0.0 max=1.0 color] vec3 Setting_SelectedRouteColor = vec3(0.2, 1, 0.3); FMetaSetting settingMeta_Setting_SelectedRouteColor = FMetaSetting( "Setting_SelectedRouteColor" , vec3(0.2, 1, 0.3), 0.0, 1.0, false, true);
[Setting category="Display" name="Route line width" description="Width of the route line." min=1.0 max=10.0 drag] float Setting_RouteLineWidth = 1.0; FMetaSetting settingMeta_Setting_RouteLineWidth = FMetaSetting( "Setting_RouteLineWidth" , 1.0, 1.0, 10.0, true);

[Setting category="Display" name="Elapsed Route Opacity" description="Line-Color Opacity before the current time." min=0.0 max=1.0] float Setting_ElapsedRouteOpacityModifier = 0.25; FMetaSetting settingMeta_Setting_ElapsedRouteOpacityModifier = FMetaSetting( "Setting_ElapsedRouteOpacityModifier" , 0.25, 0.0, 1.0);

[Setting category="Display" name="Show Car Box" description="Show the Car box.."] bool Setting_RenderCarBox = true; FMetaSetting settingMeta_Setting_RenderCarBox = FMetaSetting( "Setting_RenderCarBox" , true);
[Setting category="Display" name="Car Box color" description="Color of the car box." min=0.0 max=1.0 color] vec4 Setting_CarBoxColor = vec4(0.9f, 0.3f, 0.7f, 0.8); FMetaSetting settingMeta_Setting_CarBoxColor = FMetaSetting( "Setting_CarBoxColor" , vec4(0.9f, 0.3f, 0.7f, 0.8), 0.0, 1.0, false, true);
[Setting category="Display" name="Box line width" description="Width of the box line." min=1.0 max=10.0 drag] float Setting_BoxWidth = 1.0; FMetaSetting settingMeta_Setting_BoxWidth = FMetaSetting( "Setting_BoxWidth" , 1.0, 1.0, 10.0, true);
[Setting category="Display" name="Event scale" description="Scale of the event." min=0.4 max=2.0 drag] float Setting_EventScale = 1.0f; FMetaSetting settingMeta_Setting_EventScale = FMetaSetting( "Setting_EventScale" , 1.0f, 0.4, 2.0, true);

[Setting category="Display" name="Show Rotation Gizmo" description="Show the Rotation Gizmo."] bool Setting_RenderGizmo = true; FMetaSetting settingMeta_Setting_RenderGizmo = FMetaSetting( "Setting_RenderGizmo" , true);
[Setting category="Display" name="Gizmo line width" description="Width of the gizmo line." min=1.0 max=10.0 drag] float Setting_GizmoWidth = 2.0; FMetaSetting settingMeta_Setting_GizmoWidth = FMetaSetting( "Setting_GizmoWidth" , 2.0, 1.0, 10.0, true);
[Setting category="Display" name="Gizmo scale" description="Scale of the gizmo." min=1.0 max=10.0 drag] float Setting_GizmoScale = 2.5f; FMetaSetting settingMeta_Setting_GizmoScale = FMetaSetting( "Setting_GizmoScale" , 2.5f, 1.0, 10.0, true);


[Setting category="Display" name="Render Gear Events" description="Render gear events."] bool Setting_RenderGearEvents = true; FMetaSetting settingMeta_Setting_RenderGearEvents = FMetaSetting( "Setting_RenderGearEvents" , true);
[Setting category="Display" name="Render VehicleType Events" description="Render vehicle type events."] bool Setting_RenderVehicleTypeEvents = true; FMetaSetting settingMeta_Setting_RenderVehicleTypeEvents = FMetaSetting( "Setting_RenderVehicleTypeEvents" , true);
[Setting category="Display" name="Elapsed Event Opacity" description="Opacity of events before the current time" min=0.0 max=1.0] float Setting_ElapsedEventOpacityModifier = 0.25; FMetaSetting settingMeta_Setting_ElapsedEventOpacityModifier = FMetaSetting( "Setting_ElapsedEventOpacityModifier" , 0.25, 0.0, 1.0);

[Setting category="Interface" name="Enable Editor Route Style" description="Whether to use the custom Editor Route UI Style or the default Style."] bool bEnableEditorRouteStyle = true; FMetaSetting settingMeta_bEnableEditorRouteStyle = FMetaSetting( "bEnableEditorRouteStyle" , true);
[Setting category="Interface" name="Disable unreadable detail colors" description="Disables coloring of Stats in the UI when the text color is hard to read on the background."] bool bPreventBadSpectrumReadability = true; FMetaSetting settingMeta_bPreventBadSpectrumReadability = FMetaSetting( "bPreventBadSpectrumReadability" , true);

[Setting category="Blender Integration" name="POST URL" description="The full URL (including port) that the Editor Route will be POSTed to."] string Setting_UploadEditorRouteURL = "http://localhost:42069/trails"; FMetaSetting settingMeta_Setting_UploadEditorRouteURL = FMetaSetting( "Setting_UploadEditorRouteURL" , "http://localhost:42069/trails");

[Setting category="Experimental" name="Enable 3D-Lines" description="(Requires Editor++ Plugin) Render Lines as 3D-Lines in the World with depth-testing. Does not support different Line Widths and detailed Line Colors."] bool Setting_Enable3DLines = false; FMetaSetting settingMeta_Setting_Enable3DLines = FMetaSetting( "Setting_Enable3DLines" , false);
