
namespace CosPalette
{







	const vec3[] _A =
	{
		vec3(0.5,0.5,0.5),
		vec3(0.5,0.5,0.5),
		vec3(0.5,0.5,0.5),
		vec3(0.5,0.5,0.5),
		vec3(0.5,0.5,0.5),
		vec3(0.5,0.5,0.5),
		vec3(0.8,0.5,0.4),
		vec3(0.5,0.5,0.5),
	};
	const vec3[] _B =
	{
		vec3(0.5,0.5,0.5),
		vec3(0.5,0.5,0.5),
		vec3(0.5,0.5,0.5),
		vec3(0.5,0.5,0.5),
		vec3(0.5,0.5,0.5),
		vec3(0.5,0.5,0.5),
		vec3(0.2,0.4,0.2),
		vec3(0.5,0.5,0.5)
	};
	const vec3[] _C =
	{
		vec3(1.0,1.0,1.0),
		vec3(1.0,1.0,1.0),
		vec3(1.0,1.0,1.0),
		vec3(1.0,1.0,0.5),
		vec3(1.0,0.7,0.4),
		vec3(2.0,1.0,0.0),
		vec3(2.0,1.0,1.0),
		vec3(0.5,0.5,0.5)
	};
	const vec3[] _D =
	{
		vec3(0.0,0.33,0.67),
		vec3(0.0,0.10,0.20),
		vec3(0.3,0.20,0.20),
		vec3(0.8,0.90,0.30),
		vec3(0.0,0.15,0.20),
		vec3(0.5,0.20,0.25),
		vec3(0.0,0.25,0.25),
		vec3(-.5,-.25,0.00)
	};

	enum Presets
	{
		Rainbow = 0,
		DesertSky,
		Cream,
		Phaser,
		Variety,
		Eighties,
		Cactusflower,
		Spectrum
	};

	vec3 Col(const float t, const Presets preset)
	{
		return Col(t, _A[int(preset)], _B[int(preset)], _C[int(preset)], _D[int(preset)]);
	}

	vec3 Col(const float t, const int32 preset)
	{
		return Col(t, _A[int(preset)], _B[int(preset)], _C[int(preset)], _D[int(preset)]);
	}

	vec3 Col(const float t, const vec3 &in a, const vec3 &in b, const vec3 &in c, const vec3 &in d)
	{
		vec3 z = vec3(
			Math::Cos(6.28318f * (c.x * t + d.x)),
			Math::Cos(6.28318f * (c.y * t + d.y)),
			Math::Cos(6.28318f * (c.z * t + d.z)));
		return a + b * z;
	}

	vec3 Col(const int32 i, const Presets preset, const float fac = 0.1f)
	{
		return Col(float(i) * fac, _A[int(preset)], _B[int(preset)], _C[int(preset)], _D[int(preset)]);
	}

	vec3 Col(const int32 i, const int32 preset, const float fac = 0.1f)
	{
		return Col(float(i) * fac, _A[int(preset)], _B[int(preset)], _C[int(preset)], _D[int(preset)]);
	}

	vec3 Col(const int32 i, const vec3 &in a, const vec3 &in b, const vec3 &in c, const vec3 &in d, const float fac = 0.1f)
	{
		const float t = float(i) * fac;
		vec3 z = vec3(
			Math::Cos(6.28318f * (c.x * t + d.x)),
			Math::Cos(6.28318f * (c.y * t + d.y)),
			Math::Cos(6.28318f * (c.z * t + d.z)));
		return a + b * z;
	}
}
