void Main()
{
	Fonts::Load();
	Events::CreateCDOs();
	while (true)
	{
		yield();

		GameState::Tick();
		if (GameState::IsReadyToRecordRoute())
		{
			if (RouteContainer::HasRoutes())
			{
				RouteRecorder::Record();
			}
			else
			{
				RUtils::DebugTrace("Ready to record Routes but RouteContainer not setup!");
			}
		}
		if (GameState::IsReadyToRenderRoute())
		{

		}
	}
}

void Update(float dt)
{
	if (GameState::IsReadyToRenderRoute())
	{
		RouteTime::UpdateTime(dt);
	}


	if (GameState::State::bDoesPlayerExist)
	{
		RouteRecorder::RecordFrameTimes(dt);
	}
}

void Render()
{
	if (GameState::IsReadyToRenderRoute())
	{
		EditorRouteUI::Show();
		RouteSpectrum::ProcessRequests();

		if (EditorRouteUI::bIsWindowOpen)
		{
			RouteRenderer::Render();
		}
	}
}

void OnDestroyed()
{
	RouteRenderer::Reset();
}

void OnDisabled()
{
	RouteRenderer::Reset();
}

void RenderMenu()
{
	EditorRouteUI::RenderMenu();
}

void RenderEarly()
{
	CameraExt::Tick();
}
